/* 
   - The Original Code is this file as it was released on Februari 6, 2004.
   -
   - The Initial Developer of the Original Code is HJ van Rantwijk.
   - Portions created by HJ van Rantwijk are Copyright (C) 2004
   - HJ van Rantwijk.  All Rights Reserved.
   -
*/

// Do we want to convert this to an object?
var gHeight, gPanel, gModified = false;
var gEnableState, gNavigator, gTabbrowser, gDocument, gDialogManager, gEscapePressed = false;
var gPrefWindow, gSecondLevelPrefs = false;

if (hPrefWindow == undefined) // Fixing breakage caused by mozilla bug 228904
  var hPrefWindow = null;

function Startup()
{
  gDialogManager = window.arguments[0];
  gDialogManager.prefWindow = this;
  gHeight = (gDialogManager.innerHeight / 50 - 2);
  gPanel = gDialogManager.dialogType;

  var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
                                .getService(Components.interfaces.nsIWindowMediator);
  try { // Catch "undefined xyz" JS errors
    gNavigator = windowManager.getMostRecentWindow("navigator:browser");
    gTabbrowser = gNavigator.getBrowser();
    gDocument = gTabbrowser.contentDocument;
  } catch(ex) {
    gDialogManager.open();
    gNavigator = windowManager.getMostRecentWindow("navigator:browser");
    gTabbrowser = gNavigator.getBrowser();
  }
  if (!hPrefWindow) // Fixing breakage caused by mozilla bug 228904
    hPrefWindow = new nsPrefWindow('panelFrame');
    
  if (!hPrefWindow)
    throw "MultiZilla's dialog manager failed to initialize this pref overlay!";
  hPrefWindow.init();
  document.getElementById('mac_button_spring').hidden = !(/Mac/.test(navigator.platform));
  switchPanel(gPanel);

  if (gDialogManager.gUseStackedWindows) {
    document.documentElement.setAttribute("hidechrome", "true");
    window.outerWidth = gDialogManager.innerWidth;
    window.outerHeight = 0;
    slideOpen(0);
  }
  else {
    window.outerWidth = gDialogManager.outerWidth;
    window.outerHeight = gDialogManager.outerHeight;
    document.getElementById("main-box").collapsed = false;
  }
}

function slideOpen(aStep) // Modified Phoenix code!
{
  if (aStep < gHeight) {
    window.outerHeight += 50;
    setTimeout(slideOpen, 20, ++aStep);
  } 
  else {
    /* var defaultHeight = gDialogManager.document.documentElement.getAttribute('inner-height');

    if (gDialogManager.innerHeight < defaultHeight)
      gDialogManager.innerHeight = defaultHeight; */
    window.outerHeight = gDialogManager.innerHeight;
    document.getElementById("main-box").collapsed = false;
  }
}

function checkWindowHeight()
{
  /* 
  dump("\ngDialogManager.innerHeight: " + gDialogManager.innerHeight);
  var panel = window.frames[hPrefWindow.contentFrame].document.getElementById("panel");
  panel.builder.rebuild();
  dump("\npanel.boxObject.y: " + panel.boxObject.y);
  dump("\npanel.boxObject.x: " + panel.boxObject.x);
  dump("\npanel.boxObject.width: " + panel.boxObject.width);
  dump("\npanel.boxObject.height: " + panel.boxObject.height);
  return;
  var panelBottom = panel.boxObject.height + panel.boxObject.y;
  dump("\npanel.boxObject.height: " + panel.boxObject.height);
  dump("\npanel.boxObject.y: " + panel.boxObject.y);
  dump("\npanelBottom: " + panelBottom);
  var mainBox = document.getElementById('dialogButtonBox').boxObject;
  dump("\nmainBox.x: " + mainBox.x);
  dump("\nmainBox.y: " + mainBox.y);
  dump("\nmainBox.height: " + mainBox.height);  */

  // if (dialogButtonBox.screenY < panelBottom)
    // dump("\nWe need to adjust the window size");
}

function slideClosed(aStep) // Modified Phoenix code!
{
  document.getElementById("dialogButtonBox").collapsed = true;

  if (gDialogManager.gUseStackedWindows && aStep < gHeight) {
    window.outerHeight -= 50;
    setTimeout(slideClosed, 10, ++aStep);
  } 
  else
    window.close();
}

function initPanel()
{
  for (i in gDialogManager.managerTypes) {
    if (gPanel.match(gDialogManager.managerTypes[i]))
      break;
  }
  var panelName = gDialogManager.prefPanelNames[i];
  var headertitle = window.frames[hPrefWindow.contentFrame].document.getElementsByAttribute("headertitle", "*");
  headertitle[0].setAttribute("headertitle", panelName);

  if (hPrefWindow)
    hPrefWindow.onpageload(gPanel);
  else
    queuedTag = gPanel;
}

function switchPanel(aPanel)
{
  gPanel = aPanel;
  gDialogManager.switchPanel(aPanel);
}

function refreshPanel(panelFile, categoryButton)
{
  if (panelFile == null)
    return;

  var panelURL = gDialogManager.panelPath + panelFile;
  var contentFrame = document.getElementById(hPrefWindow.contentFrame);
  // Save pref panel settings
  var currentPanel = contentFrame.getAttribute("tag");
  hPrefWindow.wsm.savePageData(currentPanel, null);
  contentFrame.setAttribute("tag", gPanel);
  // Reload/reinitialize pref panel
  contentFrame.removeAttribute("src");
  contentFrame.setAttribute("src", panelURL);
  // Display 'Back' button for secondary level pref panels
  document.getElementById('backButton').hidden = !gSecondLevelPrefs;
  // Hide 'Cancel' button for secondary pref panels
  document.documentElement.getButton('cancel').hidden = gSecondLevelPrefs;
  // Update label and default attribute for modified pref panels
  if (gModified)
    hasModifiedPrefs();
  else
    selectDefaultButton();
  // Select category button, when available
  if (categoryButton) {
    categoryButton = document.getElementById(categoryButton);
    categoryButton.checked = true;
  }
}

function preExitCall(aEvent, aFlag)
{
  if (gModified && aFlag || gModified && gEscapePressed) {
    hasModifiedPrefs('no');

    if (gDialogManager.getConfirmation(window, 'mzWizard', 'prefPanelConfirmCloseText')) {
      if ("onOK" in hPrefWindow) // Fixing breakage caused by mozilla bug 228904
        hPrefWindow.onOK(aEvent);
      else
        hPrefWindow.onAccept(aEvent);
    }
  }
  document.getElementById("dialogButtonBox").collapsed = true;
  gDialogManager.switchTree(gPanel);
  slideClosed(0);
}

function onAccept(aEvent)
{
  preExitCall(aEvent, false);

  if ("onOK" in hPrefWindow) // Fixing breakage caused by mozilla bug 228904
    hPrefWindow.onOK(aEvent);
  else 
    hPrefWindow.onAccept(aEvent);
}

function onCancel(aEvent, aFlag)
{
  preExitCall(aEvent, aFlag);

  if (!gEscapePressed)
    hPrefWindow.onCancel(aEvent);
}

function hasModifiedPrefs(aState)
{
  var acceptButton = document.documentElement.getButton('accept');
  gModified = (aState == "no") ? false : true;
  acceptButton.disabled = !gModified;

  if (!gSecondLevelPrefs) {
    var cancelButton = document.documentElement.getButton('cancel');
    cancelButton.label = gDialogManager.stringBundle.getString('prefPanelCancelButton.label');
  }
  selectDefaultButton();
}

function selectDefaultButton()
{
  var backButton = document.getElementById('backButton');
  var acceptButton = document.documentElement.getButton('accept');
  var cancelButton = document.documentElement.getButton('cancel');
  var defaultButton = cancelButton;

  if (backButton)
    backButton.removeAttribute('default');
  acceptButton.removeAttribute('default');
  cancelButton.removeAttribute('default');

  if (gSecondLevelPrefs && backButton) 
    defaultButton = backButton;

  if (gModified)
    defaultButton = acceptButton;
  defaultButton.setAttribute('default', 'true');
  defaultButton.focus();
}

function mzSpinButton(aDocument, aElementId, aStepValue, aMinValue, aMaxValue)
{
  /***
    * The 'onup' and 'ondown' buttons/images are always functional, even 
    * when disabled, so we need to check this to prevent failures!
    */
  if (!aDocument || !aElementId)
    return;
  var spinbutton = aDocument.getElementById(aElementId);

  if (!spinbutton || spinbutton.disabled)
    return;

  var newValue = Number(spinbutton.value) + Number(aStepValue);
  spinbutton.value = (newValue > (aMinValue-1) && newValue < (aMaxValue+1)) ? newValue : (newValue < aMinValue) ? aMaxValue : aMinValue;
  hasModifiedPrefs();
}


